/* ofpec_lightbulbes.sqf v1.0 
   by OFPEC (Mandoble, Planck and Loyalguard) 

   Adds light bulbs to lamposts closer than 50m to the player, bubls states are refreshed every 4 seconds.
   Damaged streetlamps will have blinking bulbs.

 Example:
    // Part of init.sqf
    res = []execVM"ofpec_lightbulbes.sqf"
*/

private ["_types", "_lamps", "_coords", "_pos", "_colors", "_index", "_sizes", "_lifetime"];


// You may readjust the followin arrays based on lamp types
// Add more types below if needed
_types = ["Land_lampa_vysoka", "Land_lampa_ind", "Land_lampa_ind_b", "Land_lampa_sidl", "Land_lampa_ind_zebr", "Land_cwr_lampazel", "Land_cwr_lampa_cut", "Land_cwr_hangarlamp"];

// Per each type, adjust coords here relative to the model
_coords = [[-1.4,0,5.4],[-0.42,0,3.85],[-0.42,0,3.85],[-0.9,0,4.4],[-0.5,0,3.85], [-2.25,0,5.65],[1.1,-1.05,1.1],[-0.7,0,-0.4]];

// Per each type, the corresponding color [R,G,B,A]
_colors = [[0.9,0.8,0.4,0.8], [0.9,0.8,0.4,0.8], [0.9,0.8,0.4,0.8], [0.9,0.8,0.4,0.8], [0.9,0.8,0.4,0.8],[0.9,0.8,0.4,0.8],[0.9,0,0,0.8],[0.9,0.8,0.4,0.8]];

// Per each type, the corresponding bulb size
_sizes = [0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.25];


while {true} do
{
   if ((dayTime < 4.75) || (dayTime > 18.75)) then
   {
      _lamps = (getPos vehicle player) nearObjects ["StreetLamp", 75];
      {
         if ((lightIsOn _x != "OFF") && (damage _x < 0.3)) then
         {
            _index = _types find (typeOf _x);
            if (_index > -1) then
            {
               _pos = _x modelToWorld (_coords select _index);
               if (damage _x > 0.29) then
               {
                  [_pos, _sizes select _index, _colors select _index] spawn
                  {
                     drop["\ca\data\koulesvetlo","","Billboard", 100, 1,_this select 0,[0,0,0],0,25.50,20,0,[_this select 1],[_this select 2],[0],0,0,"","",""];
                     Sleep 1.1;
                     drop["\ca\data\koulesvetlo","","Billboard", 100, 1.7,_this select 0,[0,0,0],0,25.50,20,0,[_this select 1],[_this select 2],[0],0,0,"","",""];
                  };
               }
               else
               {
                  if (damage _x < 0.29) then
                  {
                     _x setDamage 0.29;
                  };    
                  _lifetime = 3.05;
                  drop["\ca\data\koulesvetlo","","Billboard", 100, _lifetime,_pos,[0,0,0],0,25.50,20,0,[_sizes select _index],[_colors select _index],[0],0,0,"","",""];
               };
            };
         };  
      } forEach _lamps;
   };
   Sleep 3;
};
